=begin
#Flagr

#Flagr is a feature flagging, A/B testing and dynamic configuration microservice. The base path for all the APIs is \"/api/v1\". 

OpenAPI spec version: 1.1.12

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.21

=end

require 'uri'

module Flagr
  class ExportApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Export JSON format of the eval cache dump
    # @param [Hash] opts the optional parameters
    # @return [Object]
    def get_export_eval_cache_json(opts = {})
      data, _status_code, _headers = get_export_eval_cache_json_with_http_info(opts)
      data
    end

    # Export JSON format of the eval cache dump
    # @param [Hash] opts the optional parameters
    # @return [Array<(Object, Fixnum, Hash)>] Object data, response status code and response headers
    def get_export_eval_cache_json_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportApi.get_export_eval_cache_json ...'
      end
      # resource path
      local_var_path = '/export/eval_cache/json'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Object')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportApi#get_export_eval_cache_json\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Export sqlite3 format of the db dump, which is converted from the main database.
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :exclude_snapshots export without snapshots data - useful for smaller db without snapshots 
    # @return [File]
    def get_export_sqlite(opts = {})
      data, _status_code, _headers = get_export_sqlite_with_http_info(opts)
      data
    end

    # Export sqlite3 format of the db dump, which is converted from the main database.
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :exclude_snapshots export without snapshots data - useful for smaller db without snapshots 
    # @return [Array<(File, Fixnum, Hash)>] File data, response status code and response headers
    def get_export_sqlite_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportApi.get_export_sqlite ...'
      end
      # resource path
      local_var_path = '/export/sqlite'

      # query parameters
      query_params = {}
      query_params[:'exclude_snapshots'] = opts[:'exclude_snapshots'] if !opts[:'exclude_snapshots'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/octet-stream'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'File')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportApi#get_export_sqlite\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
